<!DOCTYPE html>
<html lang="en">
<head>
<meta name="viewport" content="width=device-width">
<meta charset=UTF-8 />
<title>HFS %folder%</title>
<link href="/~mystyle.css" rel="stylesheet" type="text/css">
</head>
<body>

<header><nav></nav><a href="/~login">&#x1f464; %user%</a></header>
<table>

<thead><tr>
<th>
<th id="menu-bar"><button onclick="this.nextElementSibling.showModal()" title="HFS %version%">&#x2315;</button>
<dialog><input type='search' placeholder='search...' list='cat'><input type='checkbox' checked title='subf'><button onclick='this.parentNode.close()'><sup>&times;</sup></button></dialog>
<datalist id='cat'><option value="*.jpg;*.png;*.gif">image</option><option value="*.mp3;*.ogg;*.m3u">audio</option><option value="*.mp4;*.webm;*.mkv">video</option></datalist>
<progress hidden></progress>
<th><button id='upload' onclick="fileElem.click()">&#x21e7;</button>
<input type="file" id="fileElem" multiple hidden onchange="sendFiles(this.files)">
</tr></thead>

<tbody>

</tbody>
</table>

<script>var folder="%folder%"</script>
<script src="/~myscript.src"></script>
</body>
</html>

[styles]
body {background: #eef}
th {background: #47c}
tr {background: #fff}
td a[onclick]::before {content:"\1f4c1"}
/* td a[href*="."]::before {content:""} */
/* a[href$=".jpg"]::before {content:"\1f304"} */
td a[href$=".mp3"]::before {content:"\266a  "}
table {font-family:Helvetica; width:100%; border-spacing:0px 1px; }
td:first-child {width:72px}
a[onclick] {cursor: pointer}
button {height:40px; width:40px; background:#eef; margin:1px}
th:nth-child(2) {text-align:left}

[mystyle.css]
{.mime|text/css.}

a {text-decoration: none}
td a {color:black}
a[href*=login] {float: right}
button, details {cursor: pointer; background:transparent;border:none}
tr:hover td {background: #EEE} 
td div:nth-child(2) {width:200px; display:inline-block; font-size:14px} 
td div:nth-child(3) {width:100px; display:inline-block; font-size:14px}
/* td:nth-child(2) {width:72px;text-align:center} */
img {width:64px;height:64px;object-fit:cover}
details, nav {display:inline-block}
/*header {padding-top:1.6em}*/
button[onclick^=fileElem].hover { border: 1px dashed #0c0 }
{.$styles.}

[myscript.src]
//{.mime|application/javascript.}
//{ .add header|Cache-Control: public, max-age=86400.}

function bcrumbs(f) {
var path=f.split('/'), pt='', pr=''
for(pta=0;pta<path.length-1;pta++) {pt+=path[pta]+'/'; pr+='<a onclick=changel("'+pt+'")>'+(path[pta]||'Home')+'</a>/'}
return pr
}


function changel(val,para){ folder=val; para=para||'';
function urlvar(key) {return (location.search.slice(1).match(key+'=(.*)(&|$)')||'')[1]}
fetch(folder+'~files.lst?sort='+(urlvar('sort')||'n')+para).then(function(response)  //query ?sort
 {response.text().then(function(txt){writefile(txt.split(/\r?\n/))})} )
}

if(self.fetch) changel(folder)

function writefile(a){
var tbod=''
var thumbs=a.indexOf('thumb/')+1
//if(thumbs) a.splice(thumbs-2,2)  //hide thumb/
document.getElementById('upload').title= fileElem.value? a.indexOf(encodeURI(fileElem.files[0].name))+1?'ok':'ko' :''; fileElem.value=''  //
for (var i=1; i<a.length; i+=2) {
 tbod+='<tr><td>'
 if(thumbs && (['.jpg','.png','.gif'].indexOf(a[i].slice(-4))+1)) tbod+='<img src="'+folder+'thumb/'+a[i]+'" alt="&#x1f304;"/>'  //file.jpg 
 if(a[i].slice(-1)=='/')
 tbod+='</td><td><div><a onclick=changel("'+folder+a[i]+'")>'+a[i]+'</a>'  //folder
 else
 tbod+='</td><td><div><a target="l" href="'+folder+a[i]+'">'+decodeURI(a[i])+'</a>'
 tbod+='</div><div>'+a[i-1].split(',')[0]+'</div><div>'+a[i-1].split(/,0?/)[1]+'</div></td><td><input type="checkbox" class="selector" value="'+a[i]+'"></td></td></tr>'
 }  //change var ref = document.querySelector('th') in the archive addon
document.querySelector('tbody').innerHTML=tbod
document.querySelector('nav').innerHTML=bcrumbs(folder) + ' '+Math.floor(a.length/2)+'files'
//if(!a[a.length-1].slice(1)) dropzone.disabled=true  //add #{get|can upload} in hfs.filelist.tpl
}

function sendFiles(filesArray) {
var xhr = new XMLHttpRequest();
var fd = new FormData();
var progressBar = document.querySelector('progress'); progressBar.hidden=false
xhr.open("POST", folder);
for (var i=0; i<filesArray.length; i++) fd.append('myFile', filesArray[i], filesArray[i].name)
xhr.upload.onprogress = function(e) {if (e.lengthComputable) progressBar.value = e.loaded / e.total}  //
xhr.onload = function() {if(xhr.responseText) document.write(xhr.responseText); else changel(folder); progressBar.hidden=true}
xhr.send(fd)
}


var dia=document.querySelector('dialog')  //mypoly
if(!dia.showModal) {dia.showModal=function(){this.hidden=false};  dia.close=function(){this.hidden=true};  dia.setAttribute('open',''); dia.hidden=true }

document.querySelector('input[type=search]').onchange = function(){changel(folder,1*this.nextElementSibling.checked? "&search="+this.value:"&files-filter=*"+this.value+"*")}

[unauthorized]
<h1>{.!Unauthorized.}</h1>
{.!Either your user name and password do not match, or you are not permitted to access this resource..}


[not found]
<h1>{.!lv_404Error|{.!Not found.}.}</h1>
<a href="/">{.!go to root.}</a>